找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 758|回复: 0

[每日一码] 不通过事件获得鼠标光标的坐标

[复制链接]

已领礼包: 13个

财富等级: 恭喜发财

发表于 2016-9-5 13:15:01 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
AutoCAD API 提供了 AcEdInputPointManager。输入点监视器(Inputpointmonitor )能够监视用户的任何输入,包括鼠标。API还能够监视WINDOWS的消息,有时你需要不通过事件来获取鼠标的位置,下面代码是一个示例,获得当前鼠标光标的位置并转换到AutoCAD的坐标系(考虑了UCS).

  1. static void getMousePosition(void)
  2. {   
  3.     //get cursor position by Windows API
  4.      POINT CursorPos;
  5.      GetCursorPos(&CursorPos);
  6.      acedGetAcadDwgView()->ScreenToClient(&CursorPos);

  7.      //Returns the viewport number based on
  8.      // Windows client coordinates.
  9.      int vpNum = acedGetWinNum(CursorPos.x, CursorPos.y);

  10.      //Converts coordinates from AutoCAD
  11.      // drawing window
  12.      //to current active viewport's coordinates
  13.      acedDwgPoint acPt, newPt;
  14.      acedCoordFromPixelToWorld(vpNum,
  15.                                CursorPos,
  16.                                acPt);

  17.      double worldPoint[3];
  18.      acedCoordFromPixelToWorld(vpNum,
  19.                                 CPoint(CursorPos.x,
  20.                                 CursorPos.y) ,
  21.                                 worldPoint);
  22.      acutPrintf(
  23.          L"\nModel Position (no UCS): [%f, %f, %f]\n",
  24.                     worldPoint[0],
  25.                     worldPoint[1],
  26.                     worldPoint[2]);


  27.      //Take UCS translation in consideration   
  28.      AcGeMatrix3d mat;
  29.      acedGetCurrentUCS(mat);

  30.      AcGePoint3d ptUcs(worldPoint[0],
  31.                      worldPoint[1],
  32.                      worldPoint[2]);
  33.      ptUcs.transformBy(mat.inverse());

  34.      resbuf wcs;
  35.      wcs.restype = RTSHORT;
  36.      wcs.resval.rint = 0;

  37.      resbuf dcs;
  38.      dcs.restype = RTSHORT;
  39.      dcs.resval.rint = 2;

  40.      //translate the WCS coordinate to UCS
  41.      double result[3];
  42.      acedTrans(asDblArray(ptUcs),
  43.                 &wcs,
  44.                 &dcs,
  45.                 0,
  46.                 result);
  47.      acutPrintf(
  48.        L"\nModel Position (with UCS): [%f, %f, %f]\n",
  49.          result[0], result[1], result[2]);
  50. }


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-9-8 07:30 , Processed in 0.320192 second(s), 28 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表